/*
 * #LICENSE%
 * BielefeldTypeLibrary
 * ---
 * Copyright (C) 2009 - 2013 Frederic Siepmann
 * ---
 * This file is part of Bielefeld Type Library (BTL).
 * 
 * http://opensource.cit-ec.de/projects/btl
 * 
 * This file may be licensed under the terms of of the
 * GNU Lesser General Public License Version 3 (the ``LGPL''),
 * or (at your option) any later version.
 * 
 * Software distributed under the License is distributed
 * on an ``AS IS'' basis, WITHOUT WARRANTY OF ANY KIND, either
 * express or implied. See the LGPL for the specific language
 * governing rights and limitations.
 * 
 * You should have received a copy of the LGPL along with this
 * program. If not, go to http://www.gnu.org/licenses/lgpl.html
 * or write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 * 
 * The development of this software was supported by the
 * Excellence Cluster EXC 277 Cognitive Interaction Technology.
 * The Excellence Cluster EXC 277 is a grant of the Deutsche
 * Forschungsgemeinschaft (DFG) in the context of the German
 * Excellence Initiative.
 * 
 * Contributors: Florian Lier, Frederic Siepmann, Leon Ziegler, Matthias 
 * Schoepfer, Adriana-Victoria Dreyer, Agnes Swadzba, Andreas Kipp, Birte 
 * Carlmeyer, Christian Ascheberg, Daniel Nacke, Dennis Wigand, Günes Minareci, 
 * Hendrik ter Horst, Ingo Killmann, Jan Pöppel, Lukas Kettenbach, Michael 
 * Zeunert, Patrick Renner, Philipp Dresselhaus, Sebastian Meyer zu Borgsen, 
 * Soufian Jebbara, Tobias Röhlig, Torben Toeniges, Viktor Losing, Viktor Richter
 * %LICENSE#
 */

/*
 * MapPoint.h
 *
 *  Created on: Oct 13, 2010
 *      Author: ltwardon
 */

#ifndef MAPPOINT_H_
#define MAPPOINT_H_

#include <string>
#include "../../units/UnitConverter.h"

namespace airobots {

class MapPoint {

public:

	static const std::string unitValue[];

	enum Kind{
		WORLD,
		RELATIVE
	};

	static const std::string kindValue[];

	MapPoint();
	MapPoint(double x, double y, LengthUnit lengthUnit);
	MapPoint(double x, double y, Kind kind,LengthUnit lengthUnit, std::string ref);
	virtual ~MapPoint();

	double getX(LengthUnit lengthUnit) const;
	void setX(double x,LengthUnit lengthUnit);
	double getY(LengthUnit lengthUnit) const;
	void setY(double y,LengthUnit lengthUnit);
	Kind getKind() const;
	void setKind(Kind kind);
	std::string getRef() const;
	void setRef(std::string ref);

private:

	static const LengthUnit internLengthUnit = METER;
	double x;
	double y;
	Kind kind;
	std::string ref;

};

}

#endif /* MAPPOINT_H_ */
