/*
 * #LICENSE%
 * BielefeldTypeLibrary
 * ---
 * Copyright (C) 2009 - 2013 Frederic Siepmann
 * ---
 * This file is part of Bielefeld Type Library (BTL).
 * 
 * http://opensource.cit-ec.de/projects/btl
 * 
 * This file may be licensed under the terms of of the
 * GNU Lesser General Public License Version 3 (the ``LGPL''),
 * or (at your option) any later version.
 * 
 * Software distributed under the License is distributed
 * on an ``AS IS'' basis, WITHOUT WARRANTY OF ANY KIND, either
 * express or implied. See the LGPL for the specific language
 * governing rights and limitations.
 * 
 * You should have received a copy of the LGPL along with this
 * program. If not, go to http://www.gnu.org/licenses/lgpl.html
 * or write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 * 
 * The development of this software was supported by the
 * Excellence Cluster EXC 277 Cognitive Interaction Technology.
 * The Excellence Cluster EXC 277 is a grant of the Deutsche
 * Forschungsgemeinschaft (DFG) in the context of the German
 * Excellence Initiative.
 * 
 * Contributors: Florian Lier, Frederic Siepmann, Leon Ziegler, Matthias 
 * Schoepfer, Adriana-Victoria Dreyer, Agnes Swadzba, Andreas Kipp, Birte 
 * Carlmeyer, Christian Ascheberg, Daniel Nacke, Dennis Wigand, Günes Minareci, 
 * Hendrik ter Horst, Ingo Killmann, Jan Pöppel, Lukas Kettenbach, Michael 
 * Zeunert, Patrick Renner, Philipp Dresselhaus, Sebastian Meyer zu Borgsen, 
 * Soufian Jebbara, Tobias Röhlig, Torben Toeniges, Viktor Losing, Viktor Richter
 * %LICENSE#
 */

#include <stdio.h>
#include <sstream>
#include <stdlib.h>

#include "OdometryData.h"

using namespace std;
using namespace xmltio;
using namespace airobots;

std::string OdometryData::getTemplate() {

	return "<" + getBaseTag() + ">"
		+ "<GENERATOR/>"
		+ airobots::Timestamp::getTemplate() + MicroTimestamp::getTemplate()
		+ "<POSITION ref=\"world\" kind=\"absolute\" x=\"\" y=\"\" theta=\"\" />"
		+ "</" + getBaseTag() + ">";

}

OdometryData::OdometryData() : PositionData(0, 0, 0,METER,RADIAN) {

}

OdometryData::OdometryData(std::string generator, float x, float y,
		float theta,LengthUnit lU, AngleUnit aU) : PositionData(x, y, theta,lU,aU) {

}

void OdometryData::sanitizeLocation(xmltio::Location &loc) const {
	
}

void OdometryData::fillInto(xmltio::Location &loc) const {

	PositionData::fillInto(loc);

	loc[XPath(MicroTimestamp::getBaseTag())] = getReadTime();

}

void OdometryData::fromLocation(const xmltio::Location &loc_, OdometryData &odo) {

	PositionData::fromLocation(loc_, odo);

	odo.setReadTime(extract<MicroTimestamp> (loc_[XPath(
			MicroTimestamp::getBaseTag())]));

}
