/*
 * #LICENSE%
 * BielefeldTypeLibrary
 * ---
 * Copyright (C) 2009 - 2013 Frederic Siepmann
 * ---
 * This file is part of Bielefeld Type Library (BTL).
 * 
 * http://opensource.cit-ec.de/projects/btl
 * 
 * This file may be licensed under the terms of of the
 * GNU Lesser General Public License Version 3 (the ``LGPL''),
 * or (at your option) any later version.
 * 
 * Software distributed under the License is distributed
 * on an ``AS IS'' basis, WITHOUT WARRANTY OF ANY KIND, either
 * express or implied. See the LGPL for the specific language
 * governing rights and limitations.
 * 
 * You should have received a copy of the LGPL along with this
 * program. If not, go to http://www.gnu.org/licenses/lgpl.html
 * or write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 * 
 * The development of this software was supported by the
 * Excellence Cluster EXC 277 Cognitive Interaction Technology.
 * The Excellence Cluster EXC 277 is a grant of the Deutsche
 * Forschungsgemeinschaft (DFG) in the context of the German
 * Excellence Initiative.
 * 
 * Contributors: Florian Lier, Frederic Siepmann, Leon Ziegler, Matthias 
 * Schoepfer, Adriana-Victoria Dreyer, Agnes Swadzba, Andreas Kipp, Birte 
 * Carlmeyer, Christian Ascheberg, Daniel Nacke, Dennis Wigand, Günes Minareci, 
 * Hendrik ter Horst, Ingo Killmann, Jan Pöppel, Lukas Kettenbach, Michael 
 * Zeunert, Patrick Renner, Philipp Dresselhaus, Sebastian Meyer zu Borgsen, 
 * Soufian Jebbara, Tobias Röhlig, Torben Toeniges, Viktor Losing, Viktor Richter
 * %LICENSE#
 */

#include "SRPlaceData.h"

using namespace xmltio;
using namespace airobots;
using namespace std;

SRPlaceData::SRPlaceData() {
}

SRPlaceData::SRPlaceData(std::string lable, double confidence, Timestamp ts) {
	srPlaceLabel = lable;
	srPlaceConfidence = confidence;
	srPlaceTimeStamp = ts;
}

SRPlaceData::~SRPlaceData() {
}

const Timestamp SRPlaceData::getSrPlaceTimeStamp() const
{
	return srPlaceTimeStamp;
}



void SRPlaceData::setSrPlaceLabel(std::string lable)
{
	srPlaceLabel = lable;
}



void SRPlaceData::sanitizeLocation(xmltio::Location & loc) const
{
}



std::string SRPlaceData::getTemplate()
{
	return "<" + getBaseTag() + " label=\"\" confidence=\"\"><GENERATOR/>" + Timestamp::getTemplate()+ "</" + getBaseTag() + ">";
}



const std::string SRPlaceData::getSrPlaceLabel() const
{
	return srPlaceLabel;
}



const double SRPlaceData::getSrPlaceConfidence() const
{
	return srPlaceConfidence;
}



void SRPlaceData::setSrPlaceConfidence(double confidence)
{
	srPlaceConfidence = confidence;
}



void SRPlaceData::setSrPlaceTimeStamp(Timestamp timestamp)
{
	srPlaceTimeStamp = timestamp;
}



void SRPlaceData::fillInto(xmltio::Location & loc) const
{
	Type::fillInto(loc);

	loc[XPath("@label")] = getSrPlaceLabel();
	loc[XPath("@confidence")] = getSrPlaceConfidence();
	loc[XPath(Timestamp::getBaseTag())] = getTimestamp();
}



std::string SRPlaceData::getBaseTag()
{
	return "SRPLACEDATA";
}



void SRPlaceData::fromLocation(const xmltio::Location & loc, SRPlaceData & type)
{
	Type::fromLocation(loc, type);
	type.setSrPlaceLabel(extract<string>(loc[XPath("@label")]));
	type.setSrPlaceConfidence(extract<double>(loc[XPath("@confidence")]));
}


