package de.unibi.airobots.btl.data.asu;

/*
 * #LICENSE%
 * BielefeldTypeLibrary
 * ---
 * Copyright (C) 2009 - 2013 Frederic Siepmann
 * ---
 * This file is part of Bielefeld Type Library (BTL).
 * 
 * http://opensource.cit-ec.de/projects/btl
 * 
 * This file may be licensed under the terms of of the
 * GNU Lesser General Public License Version 3 (the ``LGPL''),
 * or (at your option) any later version.
 * 
 * Software distributed under the License is distributed
 * on an ``AS IS'' basis, WITHOUT WARRANTY OF ANY KIND, either
 * express or implied. See the LGPL for the specific language
 * governing rights and limitations.
 * 
 * You should have received a copy of the LGPL along with this
 * program. If not, go to http://www.gnu.org/licenses/lgpl.html
 * or write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 * 
 * The development of this software was supported by the
 * Excellence Cluster EXC 277 Cognitive Interaction Technology.
 * The Excellence Cluster EXC 277 is a grant of the Deutsche
 * Forschungsgemeinschaft (DFG) in the context of the German
 * Excellence Initiative.
 * 
 * Contributors: Florian Lier, Frederic Siepmann, Leon Ziegler, Matthias 
 * Schoepfer, Adriana-Victoria Dreyer, Agnes Swadzba, Andreas Kipp, Birte 
 * Carlmeyer, Christian Ascheberg, Daniel Nacke, Dennis Wigand, Günes Minareci, 
 * Hendrik ter Horst, Ingo Killmann, Jan Pöppel, Lukas Kettenbach, Michael 
 * Zeunert, Patrick Renner, Philipp Dresselhaus, Sebastian Meyer zu Borgsen, 
 * Soufian Jebbara, Tobias Röhlig, Torben Toeniges, Viktor Losing, Viktor Richter
 * %LICENSE#
 */

import org.junit.Test;

import de.unibi.airobots.btl.TestUtils;
import static org.junit.Assert.*;

/**
 * Tests the frame database.
 * 
 * @author malinke
 */
public final class FrameDBTest {

	private FrameDB db = new FrameDB(TestUtils.makeTestFileName("frames.xml"));

	/**
	 * Test of getFrame method, of class FrameDBOld.
	 */
	@Test
	public void testGetFrame() throws Exception {
		String frameName = "Modality";
		FrameEntry modality = db.getFrame(frameName);
		assertNotNull(modality);
		assertEquals(frameName, modality.getName());
		assertEquals(frameName, modality.getTopName());
		String emptyName = "";
		FrameEntry empty = db.getFrame(emptyName);
		assertNotNull(empty);
		assertFalse(modality.slotList().contains(empty));
		frameName = "Name_personal";
		FrameEntry namePersonal = db.getFrame(frameName);
		assertNotNull(namePersonal);
		assertFalse(namePersonal.slotList().contains(empty));
		FrameEntry questionObject = db.getFrame("Question_object");
		final int numberOfRelated = 4;
		assertEquals(numberOfRelated, questionObject.slotList().size());
	}
}
